searchData={"items":[{"type":"module","title":"wpool","doc":"Worker pool main interface. Use functions provided by this module to manage your pools of workers. Starting the application Worker Pool is an Erlang application that can be started using the functions in the application module. For convenience, wpool:start/0 and wpool:stop/0 are also provided. Starting a Pool To start a new worker pool, you can either Use wpool:child_spec/2 if you want to add the pool under a supervision tree initialisation; Use wpool:start_pool/1 or wpool:start_pool/2 if you want to supervise it yourself; Use wpool:start_sup_pool/1 or wpool:start_sup_pool/2 if you want the pool to live under wpool's supervision tree. Stopping a Pool To stop a pool, just use wpool:stop_pool/1 or wpool:stop_sup_pool/1 according to how you started the pool. Using the Workers Since the workers are gen_server s, messages can be call ed or cast ed to them. To do that you can use wpool:call and wpool:cast as you would use the equivalent functions on gen_server . Choosing a Strategy Beyond the regular parameters for gen_server , wpool also provides an extra optional parameter Strategy The strategy used to pick up the worker to perform the task. If not provided, the result of wpool:default_strategy/0 is used. The available strategies are defined in the wpool:strategy/0 type. Watching a Pool Wpool provides a way to get live statistics about a pool. To do that, you can use wpool:stats/1 .","ref":"wpool.html"},{"type":"function","title":"wpool.broadcall/3","doc":"Calls all the workers within the given pool async and waits for the responses synchronously. If one worker times out, the entire call is considered timed-out.","ref":"wpool.html#broadcall/3"},{"type":"function","title":"wpool.broadcast/2","doc":"Casts a message to all the workers within the given pool. NOTE: These messages don't get queued, they go straight to the worker's message queues, so if you're using available_worker strategy to balance the charge and you have some tasks queued up waiting for the next available worker, the broadcast will reach all the workers before the queued up tasks.","ref":"wpool.html#broadcast/2"},{"type":"function","title":"wpool.call/2","doc":"Equivalent to call(Sup, Call, default_strategy()) .","ref":"wpool.html#call/2"},{"type":"function","title":"wpool.call/3","doc":"Equivalent to call(Sup, Call, Strategy, 5000) .","ref":"wpool.html#call/3"},{"type":"function","title":"wpool.call/4","doc":"Picks a server and issues the call to it. For all strategies except available_worker, Timeout applies only to the time spent on the actual call to the worker, because time spent finding the worker in other strategies is negligible. For available_worker the time used choosing a worker is also considered","ref":"wpool.html#call/4"},{"type":"function","title":"wpool.cast/2","doc":"Equivalent to cast(Sup, Cast, default_strategy()) .","ref":"wpool.html#cast/2"},{"type":"function","title":"wpool.cast/3","doc":"Picks a server and issues the cast to it","ref":"wpool.html#cast/3"},{"type":"function","title":"wpool.child_spec/2","doc":"Builds a child specification to pass to a supervisor.","ref":"wpool.html#child_spec/2"},{"type":"function","title":"wpool.default_strategy/0","doc":"Default strategy","ref":"wpool.html#default_strategy/0"},{"type":"function","title":"wpool.get_workers/1","doc":"Retrieves the list of worker registered names. This can be useful to manually inspect the workers or do custom work on them.","ref":"wpool.html#get_workers/1"},{"type":"function","title":"wpool.send_request/2","doc":"Equivalent to send_request(Sup, Call, default_strategy(), 5000) .","ref":"wpool.html#send_request/2"},{"type":"function","title":"wpool.send_request/3","doc":"Equivalent to send_request(Sup, Call, Strategy, 5000) .","ref":"wpool.html#send_request/3"},{"type":"function","title":"wpool.send_request/4","doc":"Picks a server and issues the call to it. Timeout applies only for the time used choosing a worker in the available_worker strategy","ref":"wpool.html#send_request/4"},{"type":"function","title":"wpool.start/0","doc":"Starts the application","ref":"wpool.html#start/0"},{"type":"function","title":"wpool.start_pool/1","doc":"Equivalent to start_pool(Name, []) .","ref":"wpool.html#start_pool/1"},{"type":"function","title":"wpool.start_pool/2","doc":"Starts (and links) a pool of N wpool_processes. The result pid belongs to a supervisor (in case you want to add it to a supervisor tree)","ref":"wpool.html#start_pool/2"},{"type":"function","title":"wpool.start_sup_pool/1","doc":"Equivalent to start_sup_pool(Name, []) .","ref":"wpool.html#start_sup_pool/1"},{"type":"function","title":"wpool.start_sup_pool/2","doc":"Starts a pool of N wpool_processes supervised by wpool_sup","ref":"wpool.html#start_sup_pool/2"},{"type":"function","title":"wpool.stats/0","doc":"Retrieves a snapshot of statistics for all pools. See stats/0 for details on the return type.","ref":"wpool.html#stats/0"},{"type":"function","title":"wpool.stats/1","doc":"Retrieves a snapshot of statistics for a a given pool. See stats/0 for details on the return type.","ref":"wpool.html#stats/1"},{"type":"function","title":"wpool.stop/0","doc":"Stops the application","ref":"wpool.html#stop/0"},{"type":"function","title":"wpool.stop_pool/1","doc":"Stops a pool that doesn't belong to wpool_sup .","ref":"wpool.html#stop_pool/1"},{"type":"function","title":"wpool.stop_sup_pool/1","doc":"Stops a pool supervised by wpool_sup supervision tree.","ref":"wpool.html#stop_sup_pool/1"},{"type":"type","title":"wpool.callbacks/0","doc":"Initial list of callback modules implementing wpool_process_callbacks to be called on certain worker events. This options will only work if the enable_callbacks() is set to true . Callbacks can be added and removed later by wpool_pool:add_callback_module/2 and wpool_pool:remove_callback_module/2 .","ref":"wpool.html#t:callbacks/0"},{"type":"type","title":"wpool.custom_strategy/0","doc":"A callback that gets the pool name and returns a worker's name.","ref":"wpool.html#t:custom_strategy/0"},{"type":"type","title":"wpool.enable_callbacks/0","doc":"A boolean value determining if event_manager should be started for callback modules. Defaults to false .","ref":"wpool.html#t:enable_callbacks/0"},{"type":"type","title":"wpool.max_overrun_warnings/0","doc":"The maximum number of overrun warnings emitted before killing the worker with a delayed task. If this parameter is set to a value other than infinity the rounds of warnings become equally timed (i.e. with overrun_warning = 1000 and max_overrun_warnings = 5 the task would be killed after 5 seconds of execution). The default value for this setting is infinity , i.e., delayed tasks are not killed. NOTE : As the worker is being killed it might cause worker's messages to be missing if you are using a worker stategy other than available_worker (see worker strategy() below).","ref":"wpool.html#t:max_overrun_warnings/0"},{"type":"type","title":"wpool.name/0","doc":"Name of the pool","ref":"wpool.html#t:name/0"},{"type":"type","title":"wpool.option/0","doc":"Options that can be provided to a new pool. child_spec/2 , start_pool/2 , start_sup_pool/2 are the callbacks that take a list of these options as a parameter.","ref":"wpool.html#t:option/0"},{"type":"type","title":"wpool.options/0","doc":"Options that can be provided to a new pool. child_spec/2 , start_pool/2 , start_sup_pool/2 are the callbacks that take a list of these options as a parameter.","ref":"wpool.html#t:options/0"},{"type":"type","title":"wpool.overrun_handler/0","doc":"The module and function to call when a task is overrun The default value for this setting is {error_logger, warning_report} . The function must be of arity 1, and it will be called as Module:Fun(Args) where Args is a proplist with the following reported values: {alert, AlertType} : Where AlertType is overrun on regular warnings, or max_overrun_limit when the worker is about to be killed. {pool, Pool} : The pool name. {worker, Pid} : Pid of the worker. {task, Task} : A description of the task. {runtime, Runtime} : The runtime of the current round.","ref":"wpool.html#t:overrun_handler/0"},{"type":"type","title":"wpool.overrun_warning/0","doc":"The number of milliseconds after which a task is considered overrun i.e., delayed. A warning is emitted using overrun_handler() . The task is monitored until it is finished, thus more than one warning might be emitted for a single task. The rounds of warnings are not equally timed, an exponential backoff algorithm is used instead: after each warning the overrun time is doubled (i.e. with overrun_warning = 1000 warnings would be emitted after 1000, 2000, 4000, 8000 ...). The default value for this setting is infinity , i.e., no warnings are emitted.","ref":"wpool.html#t:overrun_warning/0"},{"type":"type","title":"wpool.pool_sup_intensity/0","doc":"The supervision intensity to use over the supervisor that supervises the workers. Defaults to 5 . See wpool_pool for more details.","ref":"wpool.html#t:pool_sup_intensity/0"},{"type":"type","title":"wpool.pool_sup_period/0","doc":"The supervision period to use over the supervisor that supervises the workers. Defaults to 60 . See wpool_pool for more details.","ref":"wpool.html#t:pool_sup_period/0"},{"type":"type","title":"wpool.pool_sup_shutdown/0","doc":"The shutdown option to be used over the supervisor that supervises the workers. Defaults to brutal_kill . See wpool_process_sup for more details.","ref":"wpool.html#t:pool_sup_shutdown/0"},{"type":"type","title":"wpool.queue_type/0","doc":"Order in which requests will be stored and handled by workers. This option can take values lifo or fifo . Defaults to fifo .","ref":"wpool.html#t:queue_type/0"},{"type":"type","title":"wpool.stats/0","doc":"Statistics about a given live pool.","ref":"wpool.html#t:stats/0"},{"type":"type","title":"wpool.strategy/0","doc":"Strategy to use when choosing a worker. best_worker Picks the worker with the shortest queue of messages. Loosely based on this article: https://lethain.com/load-balancing-across-erlang-process-groups/ . This strategy is usually useful when your workers always perform the same task, or tasks with expectedly similar runtimes. random_worker Just picks a random worker. This strategy is the fastest one to select a worker. It's ideal if your workers will perform many short tasks. next_worker Picks the next worker in a round-robin fashion. This ensures an evenly distribution of tasks. available_worker Instead of just picking one of the workers in the queue and sending the request to it, this strategy queues the request and waits until a worker is available to perform it. That may render the worker selection part of the process much slower (thus generating the need for an additional parameter: Worker_Timeout that controls how many milliseconds the client is willing to spend in that, regardless of the global Timeout for the call). This strategy ensures that, if a worker crashes, no messages are lost in its message queue. It also ensures that, if a task takes too long, that doesn't block other tasks since, as soon as other worker is free it can pick up the next task in the list. next_available_worker In a way, this strategy behaves like available_worker in the sense that it will pick the first worker that it can find which is not running any task at the moment, but the difference is that it will fail if all workers are busy. {hash_worker, Key} This strategy takes a Key and selects a worker using erlang:phash2/2 . This ensures that tasks classified under the same key will be delivered to the same worker, which is useful to classify events by key and work on them sequentially on the worker, distributing different keys across different workers. custom_strategy() A callback that gets the pool name and returns a worker's name.","ref":"wpool.html#t:strategy/0"},{"type":"type","title":"wpool.supervisor_strategy/0","doc":"Supervision strategy to use over the individual workers. Defaults to {one_for_one, 5, 60} . See wpool_process_sup for more details.","ref":"wpool.html#t:supervisor_strategy/0"},{"type":"type","title":"wpool.worker/0","doc":"The gen_server module and the arguments to pass to the init callback. This is the module that each worker will run and the InitArgs to use on the corresponding start_link call used to initiate it. The default value for this setting is {wpool_worker, undefined} . That means that if you don't provide a worker implementation, the pool will be generated with this default one. See wpool_worker for details.","ref":"wpool.html#t:worker/0"},{"type":"type","title":"wpool.worker_opt/0","doc":"Server options that will be passed to each gen_server worker. These are the same as described at the gen_server documentation.","ref":"wpool.html#t:worker_opt/0"},{"type":"type","title":"wpool.worker_shutdown/0","doc":"The shutdown option to be used over the individual workers. Defaults to 5000 . See wpool_process_sup for more details.","ref":"wpool.html#t:worker_shutdown/0"},{"type":"type","title":"wpool.worker_stats/0","doc":"Statistics about a worker in a pool.","ref":"wpool.html#t:worker_stats/0"},{"type":"type","title":"wpool.workers/0","doc":"The number of workers in the pool. The default value for this setting is 100","ref":"wpool.html#t:workers/0"},{"type":"module","title":"wpool_pool","doc":"Top supervisor for a worker_pool . This supervisor supervises wpool_process_sup (which is the worker's supervisor) together with auxiliary servers that help keep the whole pool running and in order. The strategy of this supervisor must be one_for_all but the intensity and period may be changed from their defaults by the t:wpool:pool_sup_intensity() and t:wpool:pool_sup_intensity() options respectively.","ref":"wpool_pool.html"},{"type":"function","title":"wpool_pool.add_callback_module/2","doc":"Adds a callback module. The module must implement the wpool_process_callbacks behaviour.","ref":"wpool_pool.html#add_callback_module/2"},{"type":"function","title":"wpool_pool.best_worker/1","doc":"Picks the worker with the smaller queue of messages.","ref":"wpool_pool.html#best_worker/1"},{"type":"function","title":"wpool_pool.broadcall/3","doc":"Calls all workers in the pool in parallel Waits for responses in parallel too, and it assumes that if any response times out, all of them did too and therefore exits with reason timeout like a regular gen_server does.","ref":"wpool_pool.html#broadcall/3"},{"type":"function","title":"wpool_pool.broadcast/2","doc":"Casts a message to all the workers within the given pool.","ref":"wpool_pool.html#broadcast/2"},{"type":"function","title":"wpool_pool.call_available_worker/3","doc":"Picks the first available worker and sends the call to it. The timeout provided includes the time it takes to get a worker and for it to process the call.","ref":"wpool_pool.html#call_available_worker/3"},{"type":"function","title":"wpool_pool.cast_to_available_worker/2","doc":"Casts a message to the first available worker. Since we can wait forever for a wpool:cast to be delivered but we don't want the caller to be blocked, this function just forwards the cast when it gets the worker","ref":"wpool_pool.html#cast_to_available_worker/2"},{"type":"function","title":"wpool_pool.find_wpool/1","doc":"Use this function to get the Worker pool record in a custom worker.","ref":"wpool_pool.html#find_wpool/1"},{"type":"function","title":"wpool_pool.get_workers/1","doc":"Retrieves the list of worker registered names. This can be useful to manually inspect the workers or do custom work on them.","ref":"wpool_pool.html#get_workers/1"},{"type":"function","title":"wpool_pool.hash_worker/2","doc":"Picks a worker base on a hash result. phash2 ( Term , Range ) returns hash = integer, 0 &lt;= hash &lt; Range so 1 must be added","ref":"wpool_pool.html#hash_worker/2"},{"type":"function","title":"wpool_pool.next/2","doc":"Set next within the worker pool record. Useful when using a custom strategy function.","ref":"wpool_pool.html#next/2"},{"type":"function","title":"wpool_pool.next_available_worker/1","doc":"Picks the first available worker, if any","ref":"wpool_pool.html#next_available_worker/1"},{"type":"function","title":"wpool_pool.next_worker/1","doc":"Picks the next worker in a round robin fashion","ref":"wpool_pool.html#next_worker/1"},{"type":"function","title":"wpool_pool.random_worker/1","doc":"Picks a random worker","ref":"wpool_pool.html#random_worker/1"},{"type":"function","title":"wpool_pool.remove_callback_module/2","doc":"Removes a callback module.","ref":"wpool_pool.html#remove_callback_module/2"},{"type":"function","title":"wpool_pool.send_request_available_worker/3","doc":"Picks the first available worker and sends the request to it. The timeout provided considers only the time it takes to get a worker","ref":"wpool_pool.html#send_request_available_worker/3"},{"type":"function","title":"wpool_pool.start_link/2","doc":"Starts a supervisor with several wpool_process es as its children","ref":"wpool_pool.html#start_link/2"},{"type":"function","title":"wpool_pool.stats/0","doc":"Retrieves the pool stats for all pools","ref":"wpool_pool.html#stats/0"},{"type":"function","title":"wpool_pool.stats/1","doc":"Retrieves a snapshot of the pool stats","ref":"wpool_pool.html#stats/1"},{"type":"function","title":"wpool_pool.worker_name/2","doc":null,"ref":"wpool_pool.html#worker_name/2"},{"type":"function","title":"wpool_pool.wpool_get/2","doc":"Get values from the worker pool record. Useful when using a custom strategy function.","ref":"wpool_pool.html#wpool_get/2"},{"type":"opaque","title":"wpool_pool.wpool/0","doc":null,"ref":"wpool_pool.html#t:wpool/0"},{"type":"behaviour","title":"wpool_process_callbacks","doc":null,"ref":"wpool_process_callbacks.html"},{"type":"function","title":"wpool_process_callbacks.add_callback_module/2","doc":"Adds a callback module.","ref":"wpool_process_callbacks.html#add_callback_module/2"},{"type":"callback","title":"wpool_process_callbacks.handle_init_start/1","doc":null,"ref":"wpool_process_callbacks.html#c:handle_init_start/1"},{"type":"callback","title":"wpool_process_callbacks.handle_worker_creation/1","doc":null,"ref":"wpool_process_callbacks.html#c:handle_worker_creation/1"},{"type":"callback","title":"wpool_process_callbacks.handle_worker_death/2","doc":null,"ref":"wpool_process_callbacks.html#c:handle_worker_death/2"},{"type":"function","title":"wpool_process_callbacks.notify/3","doc":"Sends a notification to all registered callback modules.","ref":"wpool_process_callbacks.html#notify/3"},{"type":"function","title":"wpool_process_callbacks.remove_callback_module/2","doc":"Removes a callback module.","ref":"wpool_process_callbacks.html#remove_callback_module/2"},{"type":"type","title":"wpool_process_callbacks.event/0","doc":null,"ref":"wpool_process_callbacks.html#t:event/0"},{"type":"type","title":"wpool_process_callbacks.state/0","doc":null,"ref":"wpool_process_callbacks.html#t:state/0"},{"type":"module","title":"wpool_process_sup","doc":"This is the supervisor that supervises the gen_server workers specifically.","ref":"wpool_process_sup.html"},{"type":"module","title":"wpool_utils","doc":"Common functions for wpool_process and other modules.","ref":"wpool_utils.html"},{"type":"function","title":"wpool_utils.add_defaults/1","doc":"Adds default parameters to a pool configuration","ref":"wpool_utils.html#add_defaults/1"},{"type":"function","title":"wpool_utils.task_end/1","doc":"Removes the current task from the worker","ref":"wpool_utils.html#task_end/1"},{"type":"function","title":"wpool_utils.task_init/2","doc":"Marks Task as started in this worker","ref":"wpool_utils.html#task_init/2"},{"type":"module","title":"wpool_worker","doc":"Default instance for wpool_process It is a module that implements a very simple RPC-like interface.","ref":"wpool_worker.html"},{"type":"function","title":"wpool_worker.call/4","doc":"Returns the result of M:F(A) from any of the workers of the pool S","ref":"wpool_worker.html#call/4"},{"type":"function","title":"wpool_worker.cast/4","doc":"Executes M:F(A) in any of the workers of the pool S","ref":"wpool_worker.html#cast/4"},{"type":"type","title":"wpool_worker.from/0","doc":null,"ref":"wpool_worker.html#t:from/0"},{"type":"opaque","title":"wpool_worker.state/0","doc":null,"ref":"wpool_worker.html#t:state/0"},{"type":"extras","title":"Worker Pool","doc":"# Worker Pool [![Build Status](https://github.com/inaka/worker_pool/actions/workflows/erlang.yml/badge.svg)](https://github.com/inaka/worker_pool/actions/workflows/erlang.yml)[![codecov](https://codecov.io/gh/inaka/worker_pool/branch/main/graph/badge.svg)](https://codecov.io/gh/inaka/worker_pool)\n\n \n\nA pool of gen servers.","ref":"readme.html"},{"type":"extras","title":"Abstract - Worker Pool","doc":"The goal of **worker pool** is pretty straightforward: to provide a transparent way to manage a pool of workers and _do the best effort_ in balancing the load among them, distributing the tasks requested to the pool.\n\nYou can just replace your calls to the `gen_server` module with calls to the `wpool` module, i.e., wherever you had a `gen_server:call/N` now you put a `wpool:call/N`, and that’s it!","ref":"readme.html#abstract"},{"type":"extras","title":"Installation - Worker Pool","doc":"Worker Pool is available on [Hex.pm](https://hex.pm/packages/worker_pool). To install, just add it to your dependencies in `rebar.config`:\n```erlang\n{deps, [{worker_pool, \"~> 6.1\"}]}.\n```\nor in `mix.ers`\n```elixir\ndefp deps() do\n  [{:worker_pool, \"~> 6.1\"}]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Documentation - Worker Pool","doc":"The documentation can be generated from code using [rebar3_ex_doc](https://github.com/starbelly/rebar3_ex_doc) with `rebar3 ex_doc`. It is also available online in [Hexdocs](https://hexdocs.pm/worker_pool/).\n\nAll user functions are exposed through the [wpool module](https://hexdocs.pm/worker_pool/wpool.html).\n\nDetailed usage is also documented in the same [wpool module summary](https://hexdocs.pm/worker_pool/doc/wpool.html#content).","ref":"readme.html#documentation"},{"type":"extras","title":"Examples - Worker Pool","doc":"Say your application needs a connection to a third-party service that is frequently used. You implement a `gen_server` called `my_server` that knows how to talk the third-party protocol and keeps the connection open, and your business logic uses this `my_server` as the API to interact with. But this server is not only a single-point-of-failure, but also a bottleneck.\n\nLet's pool this server!\n\n#### Starting the pool\n\nFirst we need to start the pool, instead of starting a single server. If your server was part of your supervision tree, and your supervisor had a child-spec like:\n```erlang\n    ChildSpec = #{id => my_server_name,\n      start => {my_server, start_link, Arguments},\n      restart => permanent,\n      shutdown => 5000,\n      type => worker}.\n```\n\nYou can now replace it by\n```erlang\n    WPoolOpts = [{worker, {my_server, Arguments}}],\n    ChildSpec = wpool:child_spec(my_server_name, WPoolOpts),\n```\n\n#### Using the pool\n\nNow that the pool is in place, wherever you've called the server, now you can simply call the pool: all code like the following\n```erlang\n    %% ...\n    gen_server:call(my_server, Request),\n    %% ...\n    gen_server:cast(my_server, Notify),\n    %% ...\n```\ncan simply be replaced by\n```erlang\n    %% ...\n    wpool:call(my_server, Request),\n    %% ...\n    wpool:cast(my_server, Notify),\n    %% ...\n```\n\nIf you want all the workers to get notified of an event (for example for consistency reasons), you can use:\n```erlang\n    wpool:broadcast(my_server, Request)\n```\n\nAnd if events have a partial ordering, that is, there is a subset of them were they should be processed in a strict ordering, for example requests by user `X` should be processed sequentially but how they interleave with other requests is irrelevant, you can use:\n```erlang\n    wpool:call(my_server, Request, {hash_worker, X})\n```\nand requests for `X` will always be sent to the same worker.\n\nAnd just like that, all your requests are now pooled!\n\nBy passing a more complex configuration in the `WPoolOpts` parameter, you can tweak many things, for example the number of workers (`t:wpool:workers()`), options to pass to OTP's the `gen_server` engine behind your code `t:wpool:worker_opt()`, the strategy to supervise all the workers (`t:wpool:strategy()`), register callbacks you want to be triggered on worker's events (`t:wpool:callbacks()`), and many more. See `t:wpool:option()` for all options available.\n\n#### Case studies used in production\n\nTo see how `wpool` is used you can check the [test](test) folder where you'll find many different scenarios exercised in the different suites.\n\nIf you want to see **worker_pool** in a _real life_ project, we recommend you to check [sumo_db](https://github.com/inaka/sumo_db), another open-source library from [Inaka](https://inaka.github.io/) that uses wpool intensively, or [MongooseIM](https://github.com/esl/MongooseIM), an Erlang Solutions' Messaging server that uses wpool in many different ways.","ref":"readme.html#examples"},{"type":"extras","title":"Benchmarks - Worker Pool","doc":"**wpool** comes with a very basic [benchmarker](https://github.com/inaka/worker_pool/blob/main/test/wpool_bench.erl) that let's you compare different strategies against the default `wpool_worker`. If you want to do the same in your project, you can use `wpool_bench` as a template and replace the worker and the tasks by your own ones.","ref":"readme.html#benchmarks"},{"type":"extras","title":"Contact Us - Worker Pool","doc":"If you find any **bugs** or have a **problem** while using this library, please [open an issue](https://github.com/inaka/worker_pool/issues/new) in this repo (or a pull request :)).","ref":"readme.html#contact-us"},{"type":"extras","title":"Requirements - Worker Pool","doc":"**Required OTP version 25** or higher. We only provide guarantees that the system runs on `OTP25+` since that's what we're testing it in, but the `minimum_otp_vsn` is `\"21\"` because some systems where **worker_pool** is integrated do require it.","ref":"readme.html#requirements"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        https://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2022 Inaka, Brujo Benavides\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       https://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}